// ContactArray.cpp: implementation of the ContactArray class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SChat.h"
#include "ContactArray.h"
#include "Contact.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ContactArray::ContactArray() {

	for( int i = 0; i < 100; i++ ) filled[i] = 0;
}

ContactArray::~ContactArray() {

	for( int i = 0; i < 100; i++ )
	{
		if( filled[i] == 1 ) {
			delete contacts[i];
		}
	}
}

int ContactArray::AddContact( BYTE _ip1, BYTE _ip2, BYTE _ip3, BYTE _ip4, CString name ) {

	for( int i = 0; i < 100; i++ ) if( filled[i] != 1 ) break;
	if( i > 100 ) {
		return -1;
	}
	contacts[i] = new Contact( _ip1, _ip2, _ip3, _ip4, name );
	filled[i] = 1;
	return i;
}

int ContactArray::DeleteContact( int cNum ) {

	if( filled[cNum] != 1 )	{
		return -1;
	}
	delete contacts[cNum];
	filled[cNum] = 0;
	return 0;
}
CString ContactArray::GetName( int cNum ) {

	if( filled[cNum] == 1 )	{
		return contacts[cNum]->cName;
	} else {
		return "";
	}
}

CString ContactArray::GetIP( int cNum ) {

	if( filled[cNum] == 1 )	{
		return contacts[cNum]->cIP;
	} else {
		return "";
	}
}

int ContactArray::SetNewName( int cNum, CString name ) {

	if( filled[cNum] ) {
		contacts[cNum]->cName = name;
		return 1;
	} else {
		return -1;
	}
}

int ContactArray::CheckIfPresents( BYTE _ip1, BYTE _ip2, BYTE _ip3, BYTE _ip4 ) {

	for( int i = 0; i < 100; i++ ) {
		if( filled[i] == 1 ) {
			if( contacts[i]->ip1 == _ip1 && contacts[i]->ip2 == _ip2 &&
				 contacts[i]->ip3 == _ip3 && contacts[i]->ip4 == _ip4 ) return i;
		}
	}
	return -1;
}

int ContactArray::CheckIfPresents( CString addr ) {

	for( int i = 0; i < 100; i++ ) {
		if( filled[i] == 1 ) {
			if( contacts[i]->cIP == addr ) return i;
		}
	}
	return -1;
}

int ContactArray::CheckIfPresents( int i ){

	if( filled[i] ) return 1;
	else return 0;
}

int ContactArray::GetTabNumber( int cNum ){

	if( filled[cNum] ) return contacts[cNum]->tabNumber;
	else return -1;
}

void ContactArray::DeleteTab( int tNum ) {
    
	for( int i = 0; i < 100; i++ ) {
		if( filled[i] ) {
			if( contacts[i]->tabNumber > tNum ) contacts[i]->tabNumber--;
			else if( contacts[i]->tabNumber == tNum ) contacts[i]->tabNumber = -1;
		}
	}
}

int ContactArray::FindByTab( int tNum ) {

	for( int i = 0; i < 100; i++ ) {
		if( filled[i] ) {
			if( contacts[i]->tabNumber == tNum ) return i;
		}
	}
	return -1;
}



